

 /******************************************************************************************
 * Filename: setup/sharer.js
 *
 * This file is part of the Sharer JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Sharer JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/sharer/
 ******************************************************************************************/


if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else if(typeof(setGetElementFunctions)!="function")
 alert("Script not loaded: getelements.js");
else
 onload("initShares();");

function initShares()
{
 var shares=document.getElementsByClassName("sharer");

 for(var c=0;c<shares.length;c++)
 {
  if(shares[c].tagName.toLowerCase()=="img"&&shares[c].parentNode.tagName.toLowerCase()=="a") //a linked share image
  {
   var m;
   if(!(m=shares[c].src.match(/(.+sharer\/images\/[0-9a-z\-]+)(_([0-9]+))?\.png$/i)))
    continue;

   shares[c].parentNode.suffix=(m[3]!=undefined?m[3]:"");
   shares[c].parentNode.onmouseout=shareNormal;
   shares[c].parentNode.onmouseup=shareNormal;
   shares[c].parentNode.onmouseover=shareHover;
   shares[c].parentNode.onmousedown=shareClick;
  }
  else if(shares[c].tagName.toLowerCase()=="input") //a share text
  {
   shares[c].onfocus=shareSelect;
  }
 }
}

function shareNormal(){return switchShare(this, this.suffix);}
function shareHover(){return switchShare(this, "2");}
function shareClick(){return switchShare(this, "3");}

function switchShare(link, suffix)
{
 var share=link.getElementsByTagName("img")[0];

 if(suffix)
  suffix="_"+suffix;

 var m;
 if(m=share.src.match(/(.+sharer\/images\/[0-9a-z\-]+)(\w+)?\.png$/i))
  share.src=m[1]+suffix+".png";

 return true;
}

function shareSelect()
{
 this.select();
}
