<?

 /******************************************************************************************
 * Filename: sharer.php
 *
 * This file is part of the Sharer JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Sharer JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/sharer/
 ******************************************************************************************/


 class Plugin_sharer extends Base_Plugin
 {
  static function shareOptions()
  {
   $options=Array(
    "email" => "Email",
    "facebook" => "Facebook",
    "gplus" => "G+",
    "linkedin" => "LinkedIn",
    "reddit" => "Reddit",
    "twitter" => "Twitter",
    "text" => "Text field",
   );

   return $options;
  }

  function main($link=false, $url=false, $title=false)
  {
   $this->link=$link;
   $this->url=$url;
   $this->title=$title;

   $this->share=Plugin_sharer::shareOptions();

   return true;
  }

  function output()
  {
   global $_config;

   $this->plugin->path["images"]=$this->plugin->path["root"]."images/";

   $output="";
   $this->e->clear();

   if($this->config)
   {
    if(in_array("email", $this->config["share"]))
     $output.=$this->link("email");

    if(in_array("facebook", $this->config["share"]))
     $output.=$this->link("facebook");

    if(in_array("gplus", $this->config["share"]))
     $output.=$this->link("gplus");

    if(in_array("linkedin", $this->config["share"]))
     $output.=$this->link("linkedin");

    if(in_array("reddit", $this->config["share"]))
     $output.=$this->link("reddit");

    if(in_array("twitter", $this->config["share"]))
     $output.=$this->link("twitter");

    if(in_array("text", $this->config["share"]))
     $output.=$this->link("text");

    return $output;
   }
   else //no config
   {
    if($this->link=="all") //show all links
    {
     $output.=$this->link("email", $this->url, $this->title);
     $output.=$this->link("facebook", $this->url, $this->title);
     $output.=$this->link("gplus", $this->url, $this->title);
     $output.=$this->link("linkedin", $this->url, $this->title);
     $output.=$this->link("reddit", $this->url, $this->title);
     $output.=$this->link("twitter", $this->url, $this->title);
     $output.=$this->link("text", $this->url, $this->title);

     return $output;
    }
    else if($this->link) //show specific link
     return $this->link($this->link, $this->url, $this->title); //use main argument to get link
   }

   return false;
  }

  function link($type=false, $url=false, $title=false)
  {
   global $_path, $_config;

   if(!preg_match("/^([a-z\-]+)$/i", $type, $tmp))
   {
    $this->e->add("Unknown sharer type: \"".$type."\"");
    return false;
   }

   if($type!="text"&&!file_exists($this->plugin->path["images"].$type."_1.png"))
   {
    $this->e->add("No icon for sharer type: \"".$type."\"");
    return false;
   }

   if(!$url)
    $url=(isset($_SERVER["HTTPS"])?"https":"http")."://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];

   if(!$title)
   {
    if(isset($this->plugin->pager)) //called from pager plugin
     $title=$this->plugin->pager->getTitle();
    else if($this->title)
     $title=$this->title;
   }

   if(isset($this->share[$type]))
    $shareTitle=$this->share[$type];
   else
    $shareTitle=$type;

   $output="";
   $image="<img src=\"".$_path["HTML"]["current"].$this->plugin->path["images"].$type."_1.png"."\" alt=\"".$shareTitle."\" class=\"sharer ".$type."\"/>";

   if($tmp[1]=="email")
    $output.="<a href=\"mailto:?subject=".str_replace("+", "%20", urlencode($title))."&amp;body=".str_replace("+", "%20", urlencode("\n".$url."\n\n"))."\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="facebook")
    $output.="<a href=\"http://www.facebook.com/sharer/sharer.php?u=".str_replace("+", "%20", urlencode($url))."&amp;t=".str_replace("+", "%20", urlencode($title))."\" rel=\"external\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="gplus")
    $output.="<a href=\"http://plus.google.com/share?url=".str_replace("+", "%20", urlencode($url))."\" rel=\"external\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="linkedin")
    $output.="<a href=\"http://www.linkedin.com/shareArticle?mini=true&amp;url=".str_replace("+", "%20", urlencode($url))."&amp;title=".str_replace("+", "%20", urlencode($title))."\" rel=\"external\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="reddit")
    $output.="<a href=\"http://www.reddit.com/submit?url=".str_replace("+", "%20", urlencode($url))."&amp;title=".str_replace("+", "%20", urlencode($title))."\" rel=\"external\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="twitter")
    $output.="<a href=\"http://www.twitter.com/intent/tweet?url=".str_replace("+", "%20", urlencode($url))."&amp;text=".str_replace("+", "%20", urlencode($title))."\" rel=\"external\" title=\"Share via ".$shareTitle."\">".$image."</a>";
   else if($tmp[1]=="text")
    $output.="<input type=\"text\" value=\"".$url."\" class=\"sharer ".$type."\"/>";
   else
    $output.=$images; //only show image

   return $output;
  }
 }

?>
